--- old/usr/src/uts/common/io/ixgbe/ixgbe_type.h	Wed Sep  7 11:32:39 2011
+++ new/usr/src/uts/common/io/ixgbe/ixgbe_type.h	Wed Sep  7 11:32:39 2011
@@ -2142,12 +2129,12 @@
 /* Transmit Descriptor - Advanced */
 union ixgbe_adv_tx_desc {
 	struct {
-		__le64 buffer_addr;	/* Address of descriptor's data buf */
+		__le64 buffer_addr;      /* Address of descriptor's data buf */
 		__le32 cmd_type_len;
 		__le32 olinfo_status;
 	} read;
 	struct {
-		__le64 rsvd;	/* Reserved */
+		__le64 rsvd;       /* Reserved */
 		__le32 nxtseq_seed;
 		__le32 status;
 	} wb;
@@ -2155,11 +2142,11 @@
 
 /* Receive Descriptor - Legacy */
 struct ixgbe_legacy_rx_desc {
-	__le64 buffer_addr;	/* Address of the descriptor's data buffer */
-	__le16 length;		/* Length of data DMAed into data buffer */
-	__le16 csum;		/* Packet checksum */
-	u8 status;		/* Descriptor status */
-	u8 errors;		/* Descriptor Errors */
+	__le64 buffer_addr; /* Address of the descriptor's data buffer */
+	__le16 length;      /* Length of data DMAed into data buffer */
+	__le16 csum;        /* Packet checksum */
+	u8 status;          /* Descriptor status */
+	u8 errors;          /* Descriptor Errors */
 	__le16 vlan;
 };
 
@@ -2174,10 +2161,8 @@
 			union {
 				__le32 data;
 				struct {
-					/* RSS type, Packet type */
-					__le16 pkt_info;
-					/* Split Header, header len */
-					__le16 hdr_info;
+					__le16 pkt_info; /* RSS, Pkt type */
+					__le16 hdr_info; /* Splithdr, hdrlen */
 				} hs_rss;
 			} lo_dword;
 			union {
@@ -2205,139 +2190,177 @@
 };
 
 /* Adv Transmit Descriptor Config Masks */
-#define	IXGBE_ADVTXD_DTALEN_MASK 0x0000FFFF /* Data buffer length(bytes) */
-#define	IXGBE_ADVTXD_MAC_LINKSEC 0x00040000 /* Insert LinkSec */
-#define	IXGBE_ADVTXD_IPSEC_SA_INDEX_MASK 0x000003FF /* IPSec SA index */
-#define	IXGBE_ADVTXD_IPSEC_ESP_LEN_MASK	0x000001FF /* IPSec ESP length */
-#define	IXGBE_ADVTXD_DTYP_MASK  0x00F00000 /* DTYP mask */
-#define	IXGBE_ADVTXD_DTYP_CTXT  0x00200000 /* Advanced Context Desc */
-#define	IXGBE_ADVTXD_DTYP_DATA  0x00300000 /* Advanced Data Descriptor */
-#define	IXGBE_ADVTXD_DCMD_EOP   IXGBE_TXD_CMD_EOP  /* End of Packet */
-#define	IXGBE_ADVTXD_DCMD_IFCS  IXGBE_TXD_CMD_IFCS /* Insert FCS */
-#define	IXGBE_ADVTXD_DCMD_RS    IXGBE_TXD_CMD_RS   /* Report Status */
-#define	IXGBE_ADVTXD_DCMD_DDTYP_ISCSI 0x10000000 /* DDP hdr type or iSCSI */
-#define	IXGBE_ADVTXD_DCMD_DEXT  IXGBE_TXD_CMD_DEXT /* Desc ext (1=Adv) */
-#define	IXGBE_ADVTXD_DCMD_VLE   IXGBE_TXD_CMD_VLE  /* VLAN pkt enable */
-#define	IXGBE_ADVTXD_DCMD_TSE   0x80000000 /* TCP Seg enable */
-#define	IXGBE_ADVTXD_STAT_DD    IXGBE_TXD_STAT_DD  /* Descriptor Done */
-#define	IXGBE_ADVTXD_STAT_SN_CRC 0x00000002 /* NXTSEQ/SEED present in WB */
-#define	IXGBE_ADVTXD_STAT_RSV   0x0000000C /* STA Reserved */
-#define	IXGBE_ADVTXD_IDX_SHIFT  4 /* Adv desc Index shift */
-#define	IXGBE_ADVTXD_CC		0x00000080 /* Check Context */
-#define	IXGBE_ADVTXD_POPTS_SHIFT	8  /* Adv desc POPTS shift */
-#define	IXGBE_ADVTXD_POPTS_IXSM (IXGBE_TXD_POPTS_IXSM << \
-	IXGBE_ADVTXD_POPTS_SHIFT)
-#define	IXGBE_ADVTXD_POPTS_TXSM (IXGBE_TXD_POPTS_TXSM << \
-	IXGBE_ADVTXD_POPTS_SHIFT)
-#define	IXGBE_ADVTXD_POPTS_ISCO_1ST   0x00000000 /* 1st TSO of iSCSI PDU */
-#define	IXGBE_ADVTXD_POPTS_ISCO_MDL   0x00000800 /* Middle TSO of iSCSI PDU */
-#define	IXGBE_ADVTXD_POPTS_ISCO_LAST  0x00001000 /* Last TSO of iSCSI PDU */
-#define	IXGBE_ADVTXD_POPTS_ISCO_FULL  0x00001800
-					/* 1st&Last TSO-full iSCSI PDU */
-#define	IXGBE_ADVTXD_POPTS_RSV  0x00002000 /* POPTS Reserved */
-#define	IXGBE_ADVTXD_PAYLEN_SHIFT  14 /* Adv desc PAYLEN shift */
-#define	IXGBE_ADVTXD_MACLEN_SHIFT  9  /* Adv ctxt desc mac len shift */
-#define	IXGBE_ADVTXD_VLAN_SHIFT    16  /* Adv ctxt vlan tag shift */
-#define	IXGBE_ADVTXD_TUCMD_IPV4    0x00000400  /* IP Packet Type: 1=IPv4 */
-#define	IXGBE_ADVTXD_TUCMD_IPV6    0x00000000  /* IP Packet Type: 0=IPv6 */
-#define	IXGBE_ADVTXD_TUCMD_L4T_UDP 0x00000000  /* L4 Packet TYPE of UDP */
-#define	IXGBE_ADVTXD_TUCMD_L4T_TCP 0x00000800  /* L4 Packet TYPE of TCP */
-#define	IXGBE_ADVTXD_TUCMD_L4T_SCTP	0x00001000  /* L4 Packet TYPE of SCTP */
-#define	IXGBE_ADVTXD_TUCMD_MKRREQ  0x00002000 /* Req requires Markers and CRC */
-#define	IXGBE_ADVTXD_POPTS_IPSEC  0x00000400 /* IPSec offload request */
-#define	IXGBE_ADVTXD_TUCMD_IPSEC_TYPE_ESP 0x00002000 /* IPSec Type ESP */
-#define	IXGBE_ADVTXD_TUCMD_IPSEC_ENCRYPT_EN 0x00004000 /* ESP Encrypt Enable */
-#define	IXGBE_ADVTXT_TUCMD_FCOE		0x00008000	/* FCoE Frame Type */
-#define	IXGBE_ADVTXD_FCOEF_EOF_MASK	(0x3 << 10)	/* FC EOF index */
-#define	IXGBE_ADVTXD_FCOEF_SOF		((1 << 2) << 10) /* FC SOF index */
-#define	IXGBE_ADVTXD_FCOEF_PARINC	((1 << 3) << 10) /* Rel_Off in F_CTL */
-#define	IXGBE_ADVTXD_FCOEF_ORIE	((1 << 4) << 10) /* Orientation: End */
-#define	IXGBE_ADVTXD_FCOEF_ORIS	((1 << 5) << 10) /* Orientation: Start */
-#define	IXGBE_ADVTXD_FCOEF_EOF_N	(0x0 << 10)	/* 00: EOFn */
-#define	IXGBE_ADVTXD_FCOEF_EOF_T	(0x1 << 10)	/* 01: EOFt */
-#define	IXGBE_ADVTXD_FCOEF_EOF_NI	(0x2 << 10)	/* 10: EOFni */
-#define	IXGBE_ADVTXD_FCOEF_EOF_A	(0x3 << 10)	/* 11: EOFa */
-#define	IXGBE_ADVTXD_L4LEN_SHIFT   8  /* Adv ctxt L4LEN shift */
-#define	IXGBE_ADVTXD_MSS_SHIFT	16  /* Adv ctxt MSS shift */
+#define IXGBE_ADVTXD_DTALEN_MASK      0x0000FFFF /* Data buf length(bytes) */
+#define IXGBE_ADVTXD_MAC_LINKSEC      0x00040000 /* Insert LinkSec */
+#define IXGBE_ADVTXD_IPSEC_SA_INDEX_MASK   0x000003FF /* IPSec SA index */
+#define IXGBE_ADVTXD_IPSEC_ESP_LEN_MASK    0x000001FF /* IPSec ESP length */
+#define IXGBE_ADVTXD_DTYP_MASK  0x00F00000 /* DTYP mask */
+#define IXGBE_ADVTXD_DTYP_CTXT  0x00200000 /* Advanced Context Desc */
+#define IXGBE_ADVTXD_DTYP_DATA  0x00300000 /* Advanced Data Descriptor */
+#define IXGBE_ADVTXD_DCMD_EOP   IXGBE_TXD_CMD_EOP  /* End of Packet */
+#define IXGBE_ADVTXD_DCMD_IFCS  IXGBE_TXD_CMD_IFCS /* Insert FCS */
+#define IXGBE_ADVTXD_DCMD_RS    IXGBE_TXD_CMD_RS   /* Report Status */
+#define IXGBE_ADVTXD_DCMD_DDTYP_ISCSI 0x10000000    /* DDP hdr type or iSCSI */
+#define IXGBE_ADVTXD_DCMD_DEXT  IXGBE_TXD_CMD_DEXT /* Desc ext (1=Adv) */
+#define IXGBE_ADVTXD_DCMD_VLE   IXGBE_TXD_CMD_VLE  /* VLAN pkt enable */
+#define IXGBE_ADVTXD_DCMD_TSE   0x80000000 /* TCP Seg enable */
+#define IXGBE_ADVTXD_STAT_DD    IXGBE_TXD_STAT_DD  /* Descriptor Done */
+#define IXGBE_ADVTXD_STAT_SN_CRC      0x00000002 /* NXTSEQ/SEED pres in WB */
+#define IXGBE_ADVTXD_STAT_RSV   0x0000000C /* STA Reserved */
+#define IXGBE_ADVTXD_IDX_SHIFT  4 /* Adv desc Index shift */
+#define IXGBE_ADVTXD_CC         0x00000080 /* Check Context */
+#define IXGBE_ADVTXD_POPTS_SHIFT      8  /* Adv desc POPTS shift */
+#define IXGBE_ADVTXD_POPTS_IXSM (IXGBE_TXD_POPTS_IXSM << \
+                                 IXGBE_ADVTXD_POPTS_SHIFT)
+#define IXGBE_ADVTXD_POPTS_TXSM (IXGBE_TXD_POPTS_TXSM << \
+                                 IXGBE_ADVTXD_POPTS_SHIFT)
+#define IXGBE_ADVTXD_POPTS_ISCO_1ST  0x00000000 /* 1st TSO of iSCSI PDU */
+#define IXGBE_ADVTXD_POPTS_ISCO_MDL  0x00000800 /* Middle TSO of iSCSI PDU */
+#define IXGBE_ADVTXD_POPTS_ISCO_LAST 0x00001000 /* Last TSO of iSCSI PDU */
+#define IXGBE_ADVTXD_POPTS_ISCO_FULL 0x00001800 /* 1st&Last TSO-full iSCSI PDU */
+#define IXGBE_ADVTXD_POPTS_RSV       0x00002000 /* POPTS Reserved */
+#define IXGBE_ADVTXD_PAYLEN_SHIFT    14 /* Adv desc PAYLEN shift */
+#define IXGBE_ADVTXD_MACLEN_SHIFT    9  /* Adv ctxt desc mac len shift */
+#define IXGBE_ADVTXD_VLAN_SHIFT      16  /* Adv ctxt vlan tag shift */
+#define IXGBE_ADVTXD_TUCMD_IPV4      0x00000400  /* IP Packet Type: 1=IPv4 */
+#define IXGBE_ADVTXD_TUCMD_IPV6      0x00000000  /* IP Packet Type: 0=IPv6 */
+#define IXGBE_ADVTXD_TUCMD_L4T_UDP   0x00000000  /* L4 Packet TYPE of UDP */
+#define IXGBE_ADVTXD_TUCMD_L4T_TCP   0x00000800  /* L4 Packet TYPE of TCP */
+#define IXGBE_ADVTXD_TUCMD_L4T_SCTP  0x00001000  /* L4 Packet TYPE of SCTP */
+#define IXGBE_ADVTXD_TUCMD_MKRREQ    0x00002000 /*Req requires Markers and CRC*/
+#define IXGBE_ADVTXD_POPTS_IPSEC      0x00000400 /* IPSec offload request */
+#define IXGBE_ADVTXD_TUCMD_IPSEC_TYPE_ESP 0x00002000 /* IPSec Type ESP */
+#define IXGBE_ADVTXD_TUCMD_IPSEC_ENCRYPT_EN 0x00004000/* ESP Encrypt Enable */
+#define IXGBE_ADVTXT_TUCMD_FCOE      0x00008000       /* FCoE Frame Type */
+#define IXGBE_ADVTXD_FCOEF_EOF_MASK  (0x3 << 10)      /* FC EOF index */
+#define IXGBE_ADVTXD_FCOEF_SOF       ((1 << 2) << 10) /* FC SOF index */
+#define IXGBE_ADVTXD_FCOEF_PARINC    ((1 << 3) << 10) /* Rel_Off in F_CTL */
+#define IXGBE_ADVTXD_FCOEF_ORIE      ((1 << 4) << 10) /* Orientation: End */
+#define IXGBE_ADVTXD_FCOEF_ORIS      ((1 << 5) << 10) /* Orientation: Start */
+#define IXGBE_ADVTXD_FCOEF_EOF_N     (0x0 << 10)      /* 00: EOFn */
+#define IXGBE_ADVTXD_FCOEF_EOF_T     (0x1 << 10)      /* 01: EOFt */
+#define IXGBE_ADVTXD_FCOEF_EOF_NI    (0x2 << 10)      /* 10: EOFni */
+#define IXGBE_ADVTXD_FCOEF_EOF_A     (0x3 << 10)      /* 11: EOFa */
+#define IXGBE_ADVTXD_L4LEN_SHIFT     8  /* Adv ctxt L4LEN shift */
+#define IXGBE_ADVTXD_MSS_SHIFT       16  /* Adv ctxt MSS shift */
 
 /* Autonegotiation advertised speeds */
 typedef u32 ixgbe_autoneg_advertised;
 /* Link speed */
 typedef u32 ixgbe_link_speed;
-#define	IXGBE_LINK_SPEED_UNKNOWN   0
-#define	IXGBE_LINK_SPEED_100_FULL  0x0008
-#define	IXGBE_LINK_SPEED_1GB_FULL  0x0020
-#define	IXGBE_LINK_SPEED_10GB_FULL 0x0080
-#define	IXGBE_LINK_SPEED_82598_AUTONEG (IXGBE_LINK_SPEED_1GB_FULL | \
-	IXGBE_LINK_SPEED_10GB_FULL)
-#define	IXGBE_LINK_SPEED_82599_AUTONEG (IXGBE_LINK_SPEED_100_FULL | \
-	IXGBE_LINK_SPEED_1GB_FULL | IXGBE_LINK_SPEED_10GB_FULL)
+#define IXGBE_LINK_SPEED_UNKNOWN   0
+#define IXGBE_LINK_SPEED_100_FULL  0x0008
+#define IXGBE_LINK_SPEED_1GB_FULL  0x0020
+#define IXGBE_LINK_SPEED_10GB_FULL 0x0080
+#define IXGBE_LINK_SPEED_82598_AUTONEG (IXGBE_LINK_SPEED_1GB_FULL | \
+                                        IXGBE_LINK_SPEED_10GB_FULL)
+#define IXGBE_LINK_SPEED_82599_AUTONEG (IXGBE_LINK_SPEED_100_FULL | \
+                                        IXGBE_LINK_SPEED_1GB_FULL | \
+                                        IXGBE_LINK_SPEED_10GB_FULL)
 
+
 /* Physical layer type */
 typedef u32 ixgbe_physical_layer;
-#define	IXGBE_PHYSICAL_LAYER_UNKNOWN		0
-#define	IXGBE_PHYSICAL_LAYER_10GBASE_T		0x0001
-#define	IXGBE_PHYSICAL_LAYER_1000BASE_T		0x0002
-#define	IXGBE_PHYSICAL_LAYER_100BASE_TX		0x0004
-#define	IXGBE_PHYSICAL_LAYER_SFP_PLUS_CU	0x0008
-#define	IXGBE_PHYSICAL_LAYER_10GBASE_LR		0x0010
-#define	IXGBE_PHYSICAL_LAYER_10GBASE_LRM	0x0020
-#define	IXGBE_PHYSICAL_LAYER_10GBASE_SR		0x0040
-#define	IXGBE_PHYSICAL_LAYER_10GBASE_KX4	0x0080
-#define	IXGBE_PHYSICAL_LAYER_10GBASE_CX4	0x0100
-#define	IXGBE_PHYSICAL_LAYER_1000BASE_KX	0x0200
-#define	IXGBE_PHYSICAL_LAYER_1000BASE_BX	0x0400
-#define	IXGBE_PHYSICAL_LAYER_10GBASE_KR		0x0800
-#define	IXGBE_PHYSICAL_LAYER_10GBASE_XAUI	0x1000
-#define	IXGBE_PHYSICAL_LAYER_SFP_ACTIVE_DA	0x2000
+#define IXGBE_PHYSICAL_LAYER_UNKNOWN      0
+#define IXGBE_PHYSICAL_LAYER_10GBASE_T    0x0001
+#define IXGBE_PHYSICAL_LAYER_1000BASE_T   0x0002
+#define IXGBE_PHYSICAL_LAYER_100BASE_TX   0x0004
+#define IXGBE_PHYSICAL_LAYER_SFP_PLUS_CU  0x0008
+#define IXGBE_PHYSICAL_LAYER_10GBASE_LR   0x0010
+#define IXGBE_PHYSICAL_LAYER_10GBASE_LRM  0x0020
+#define IXGBE_PHYSICAL_LAYER_10GBASE_SR   0x0040
+#define IXGBE_PHYSICAL_LAYER_10GBASE_KX4  0x0080
+#define IXGBE_PHYSICAL_LAYER_10GBASE_CX4  0x0100
+#define IXGBE_PHYSICAL_LAYER_1000BASE_KX  0x0200
+#define IXGBE_PHYSICAL_LAYER_1000BASE_BX  0x0400
+#define IXGBE_PHYSICAL_LAYER_10GBASE_KR   0x0800
+#define IXGBE_PHYSICAL_LAYER_10GBASE_XAUI 0x1000
+#define IXGBE_PHYSICAL_LAYER_SFP_ACTIVE_DA 0x2000
 
-/* Software ATR hash keys */
-#define	IXGBE_ATR_BUCKET_HASH_KEY	0xE214AD3D
-#define	IXGBE_ATR_SIGNATURE_HASH_KEY	0x14364D17
+/* Flow Control Macros */
+#define PAUSE_RTT	8
+#define PAUSE_MTU(MTU)	((MTU + 1024 - 1) / 1024)
 
-/* Software ATR input stream offsets and masks */
-#define	IXGBE_ATR_VLAN_OFFSET		0
-#define	IXGBE_ATR_SRC_IPV6_OFFSET	2
-#define	IXGBE_ATR_SRC_IPV4_OFFSET	14
-#define	IXGBE_ATR_DST_IPV6_OFFSET	18
-#define	IXGBE_ATR_DST_IPV4_OFFSET	30
-#define	IXGBE_ATR_SRC_PORT_OFFSET	34
-#define	IXGBE_ATR_DST_PORT_OFFSET	36
-#define	IXGBE_ATR_FLEX_BYTE_OFFSET	38
-#define	IXGBE_ATR_VM_POOL_OFFSET	40
-#define	IXGBE_ATR_L4TYPE_OFFSET		41
+#define FC_HIGH_WATER(MTU) ((((PAUSE_RTT + PAUSE_MTU(MTU)) * 144) + 99) / 100 +\
+				PAUSE_MTU(MTU))
+#define FC_LOW_WATER(MTU)  (2 * (2 * PAUSE_MTU(MTU) + PAUSE_RTT))
 
-#define	IXGBE_ATR_L4TYPE_MASK		0x3
-#define	IXGBE_ATR_L4TYPE_IPV6_MASK	0x4
-#define	IXGBE_ATR_L4TYPE_UDP		0x1
-#define	IXGBE_ATR_L4TYPE_TCP		0x2
-#define	IXGBE_ATR_L4TYPE_SCTP		0x3
-#define	IXGBE_ATR_HASH_MASK		0x7fff
+/* Software ATR hash keys */
+#define IXGBE_ATR_BUCKET_HASH_KEY    0x3DAD14E2
+#define IXGBE_ATR_SIGNATURE_HASH_KEY 0x174D3614
 
+/* Software ATR input stream values and masks */
+#define IXGBE_ATR_HASH_MASK     0x7fff
+#define IXGBE_ATR_L4TYPE_MASK      0x3
+#define IXGBE_ATR_L4TYPE_UDP       0x1
+#define IXGBE_ATR_L4TYPE_TCP       0x2
+#define IXGBE_ATR_L4TYPE_SCTP      0x3
+#define IXGBE_ATR_L4TYPE_IPV6_MASK 0x4
+enum ixgbe_atr_flow_type {
+	IXGBE_ATR_FLOW_TYPE_IPV4   = 0x0,
+	IXGBE_ATR_FLOW_TYPE_UDPV4  = 0x1,
+	IXGBE_ATR_FLOW_TYPE_TCPV4  = 0x2,
+	IXGBE_ATR_FLOW_TYPE_SCTPV4 = 0x3,
+	IXGBE_ATR_FLOW_TYPE_IPV6   = 0x4,
+	IXGBE_ATR_FLOW_TYPE_UDPV6  = 0x5,
+	IXGBE_ATR_FLOW_TYPE_TCPV6  = 0x6,
+	IXGBE_ATR_FLOW_TYPE_SCTPV6 = 0x7,
+};
+
 /* Flow Director ATR input struct. */
-struct ixgbe_atr_input {
+union ixgbe_atr_input {
 	/*
 	 * Byte layout in order, all values with MSB first:
 	 *
-	 * vlan_id	- 2 bytes
-	 * src_ip	- 16 bytes
-	 * dst_ip	- 16 bytes
-	 * src_port	- 2 bytes
-	 * dst_port	- 2 bytes
-	 * flex_bytes	- 2 bytes
-	 * vm_pool	- 1 byte
-	 * l4type	- 1 byte
+	 * vm_pool    - 1 byte
+	 * flow_type  - 1 byte
+	 * vlan_id    - 2 bytes
+	 * src_ip     - 16 bytes
+	 * dst_ip     - 16 bytes
+	 * src_port   - 2 bytes
+	 * dst_port   - 2 bytes
+	 * flex_bytes - 2 bytes
+	 * rsvd0      - 2 bytes - space reserved must be 0.
 	 */
-	u8 byte_stream[42];
+	struct {
+		u8     vm_pool;
+		u8     flow_type;
+		__be16 vlan_id;
+		__be32 dst_ip[4];
+		__be32 src_ip[4];
+		__be16 src_port;
+		__be16 dst_port;
+		__be16 flex_bytes;
+		__be16 rsvd0;
+	} formatted;
+	__be32 dword_stream[11];
 };
 
+/* Flow Director compressed ATR hash input struct */
+union ixgbe_atr_hash_dword {
+	struct {
+		u8 vm_pool;
+		u8 flow_type;
+		__be16 vlan_id;
+	} formatted;
+	__be32 ip;
+	struct {
+		__be16 src;
+		__be16 dst;
+	} port;
+	__be16 flex_bytes;
+	__be32 dword;
+};
+
+
 struct ixgbe_atr_input_masks {
-	u32 src_ip_mask;
-	u32 dst_ip_mask;
-	u16 src_port_mask;
-	u16 dst_port_mask;
-	u16 vlan_id_mask;
-	u16 data_mask;
+	__be16 rsvd0;
+	__be16 vlan_id_mask;
+	__be32 dst_ip_mask[4];
+	__be32 src_ip_mask[4];
+	__be16 src_port_mask;
+	__be16 dst_port_mask;
+	__be16 flex_mask;
 };
 
 /*
@@ -2346,9 +2369,9 @@
  * Enabled: Present; boot order is set for at least one target on the port.
  */
 enum ixgbe_fcoe_boot_status {
-    ixgbe_fcoe_bootstatus_disabled = 0,
-    ixgbe_fcoe_bootstatus_enabled = 1,
-    ixgbe_fcoe_bootstatus_unavailable = 0xFFFF
+    ixgbe_fcoe_bootstatus_disabled        = 0,
+    ixgbe_fcoe_bootstatus_enabled         = 1,
+    ixgbe_fcoe_bootstatus_unavailable     = 0xFFFF
 };
 
 enum ixgbe_eeprom_type {
@@ -2382,7 +2405,7 @@
 	ixgbe_phy_sfp_ftl_active,
 	ixgbe_phy_sfp_unknown,
 	ixgbe_phy_sfp_intel,
-	ixgbe_phy_sfp_unsupported, /* Enforce bit set with unsupported module */
+	ixgbe_phy_sfp_unsupported, /*Enforce bit set with unsupported module*/
 	ixgbe_phy_generic
 };
 
@@ -2389,11 +2412,11 @@
 /*
  * SFP+ module type IDs:
  *
- * ID   Module Type
+ * ID	Module Type
  * =============
- * 0    SFP_DA_CU
- * 1    SFP_SR
- * 2    SFP_LR
+ * 0	SFP_DA_CU
+ * 1	SFP_SR
+ * 2	SFP_LR
  * 3    SFP_DA_CU_CORE0 - 82599-specific
  * 4    SFP_DA_CU_CORE1 - 82599-specific
  * 5    SFP_SR/LR_CORE0 - 82599-specific
@@ -2434,7 +2457,7 @@
 };
 
 /* Smart Speed Settings */
-#define	IXGBE_SMARTSPEED_MAX_RETRIES	3
+#define IXGBE_SMARTSPEED_MAX_RETRIES	3
 enum ixgbe_smart_speed {
 	ixgbe_smart_speed_auto = 0,
 	ixgbe_smart_speed_on,
@@ -2453,13 +2476,13 @@
 /* PCI bus speeds */
 enum ixgbe_bus_speed {
 	ixgbe_bus_speed_unknown = 0,
-	ixgbe_bus_speed_33 = 33,
-	ixgbe_bus_speed_66 = 66,
-	ixgbe_bus_speed_100 = 100,
-	ixgbe_bus_speed_120 = 120,
-	ixgbe_bus_speed_133 = 133,
-	ixgbe_bus_speed_2500 = 2500,
-	ixgbe_bus_speed_5000 = 5000,
+	ixgbe_bus_speed_33      = 33,
+	ixgbe_bus_speed_66      = 66,
+	ixgbe_bus_speed_100     = 100,
+	ixgbe_bus_speed_120     = 120,
+	ixgbe_bus_speed_133     = 133,
+	ixgbe_bus_speed_2500    = 2500,
+	ixgbe_bus_speed_5000    = 5000,
 	ixgbe_bus_speed_reserved
 };
 
@@ -2470,8 +2493,8 @@
 	ixgbe_bus_width_pcie_x2 = 2,
 	ixgbe_bus_width_pcie_x4 = 4,
 	ixgbe_bus_width_pcie_x8 = 8,
-	ixgbe_bus_width_32 = 32,
-	ixgbe_bus_width_64 = 64,
+	ixgbe_bus_width_32      = 32,
+	ixgbe_bus_width_64      = 64,
 	ixgbe_bus_width_reserved
 };
 
@@ -2583,7 +2606,7 @@
 
 /* iterator type for walking multicast address lists */
 typedef u8* (*ixgbe_mc_addr_itr) (struct ixgbe_hw *hw, u8 **mc_addr_ptr,
-	u32 *vmdq);
+                                  u32 *vmdq);
 
 /* Function pointer table */
 struct ixgbe_eeprom_operations {
@@ -2612,8 +2635,8 @@
 	s32 (*stop_adapter)(struct ixgbe_hw *);
 	s32 (*get_bus_info)(struct ixgbe_hw *);
 	void (*set_lan_id)(struct ixgbe_hw *);
-	s32 (*read_analog_reg8)(struct ixgbe_hw *, u32, u8 *);
-	s32 (*write_analog_reg8)(struct ixgbe_hw *, u32, u8);
+	s32 (*read_analog_reg8)(struct ixgbe_hw*, u32, u8*);
+	s32 (*write_analog_reg8)(struct ixgbe_hw*, u32, u8);
 	s32 (*setup_sfp)(struct ixgbe_hw *);
 	s32 (*enable_rx_dma)(struct ixgbe_hw *, u32);
 	s32 (*acquire_swfw_sync)(struct ixgbe_hw *, u16);
@@ -2626,7 +2649,7 @@
 	s32 (*setup_link)(struct ixgbe_hw *, ixgbe_link_speed, bool, bool);
 	s32 (*check_link)(struct ixgbe_hw *, ixgbe_link_speed *, bool *, bool);
 	s32 (*get_link_capabilities)(struct ixgbe_hw *, ixgbe_link_speed *,
-	    bool *);
+	                             bool *);
 
 	/* LED */
 	s32 (*led_on)(struct ixgbe_hw *, u32);
@@ -2642,14 +2665,16 @@
 	s32 (*clear_vmdq)(struct ixgbe_hw *, u32, u32);
 	s32 (*init_rx_addrs)(struct ixgbe_hw *);
 	s32 (*update_uc_addr_list)(struct ixgbe_hw *, u8 *, u32,
-	    ixgbe_mc_addr_itr);
+	                           ixgbe_mc_addr_itr);
 	s32 (*update_mc_addr_list)(struct ixgbe_hw *, u8 *, u32,
-	    ixgbe_mc_addr_itr);
+	                           ixgbe_mc_addr_itr);
 	s32 (*enable_mc)(struct ixgbe_hw *);
 	s32 (*disable_mc)(struct ixgbe_hw *);
 	s32 (*clear_vfta)(struct ixgbe_hw *);
 	s32 (*set_vfta)(struct ixgbe_hw *, u32, u32, bool);
 	s32 (*init_uta_tables)(struct ixgbe_hw *);
+	void (*set_mac_anti_spoofing)(struct ixgbe_hw *, bool, int);
+	void (*set_vlan_anti_spoofing)(struct ixgbe_hw *, bool, int);
 
 	/* Flow Control */
 	s32 (*fc_enable)(struct ixgbe_hw *, s32);
@@ -2664,12 +2689,12 @@
 	s32 (*write_reg)(struct ixgbe_hw *, u32, u32, u16);
 	s32 (*setup_link)(struct ixgbe_hw *);
 	s32 (*setup_link_speed)(struct ixgbe_hw *, ixgbe_link_speed, bool,
-	    bool);
+	                        bool);
 	s32 (*check_link)(struct ixgbe_hw *, ixgbe_link_speed *, bool *);
 	s32 (*get_firmware_version)(struct ixgbe_hw *, u16 *);
 	s32 (*read_i2c_byte)(struct ixgbe_hw *, u8, u8, u8 *);
 	s32 (*write_i2c_byte)(struct ixgbe_hw *, u8, u8, u8);
-	s32 (*read_i2c_eeprom)(struct ixgbe_hw *, u8, u8 *);
+	s32 (*read_i2c_eeprom)(struct ixgbe_hw *, u8 , u8 *);
 	s32 (*write_i2c_eeprom)(struct ixgbe_hw *, u8, u8);
 	void (*i2c_bus_clear)(struct ixgbe_hw *);
 	s32 (*check_overtemp)(struct ixgbe_hw *);
@@ -2676,117 +2701,116 @@
 };
 
 struct ixgbe_eeprom_info {
-	struct ixgbe_eeprom_operations	ops;
-	enum ixgbe_eeprom_type		type;
-	u32				semaphore_delay;
-	u16				word_size;
-	u16				address_bits;
+	struct ixgbe_eeprom_operations  ops;
+	enum ixgbe_eeprom_type          type;
+	u32                             semaphore_delay;
+	u16                             word_size;
+	u16                             address_bits;
 };
 
-#define	IXGBE_FLAGS_DOUBLE_RESET_REQUIRED	0x01
+#define IXGBE_FLAGS_DOUBLE_RESET_REQUIRED	0x01
 struct ixgbe_mac_info {
-	struct ixgbe_mac_operations	ops;
-	enum ixgbe_mac_type		type;
-	u8				addr[IXGBE_ETH_LENGTH_OF_ADDRESS];
-	u8				perm_addr[IXGBE_ETH_LENGTH_OF_ADDRESS];
-	u8				san_addr[IXGBE_ETH_LENGTH_OF_ADDRESS];
+	struct ixgbe_mac_operations     ops;
+	enum ixgbe_mac_type             type;
+	u8                              addr[IXGBE_ETH_LENGTH_OF_ADDRESS];
+	u8                              perm_addr[IXGBE_ETH_LENGTH_OF_ADDRESS];
+	u8                              san_addr[IXGBE_ETH_LENGTH_OF_ADDRESS];
 	/* prefix for World Wide Node Name (WWNN) */
-	u16				wwnn_prefix;
+	u16                             wwnn_prefix;
 	/* prefix for World Wide Port Name (WWPN) */
-	u16				wwpn_prefix;
-#define	IXGBE_MAX_MTA			128
+	u16                             wwpn_prefix;
+#define IXGBE_MAX_MTA			128
 	u32				mta_shadow[IXGBE_MAX_MTA];
-	s32				mc_filter_type;
-	u32				mcft_size;
-	u32				vft_size;
-	u32				num_rar_entries;
-	u32				rar_highwater;
-	u32				max_tx_queues;
-	u32				max_rx_queues;
-	u32				max_msix_vectors;
-	bool				msix_vectors_from_pcie;
-	u32				orig_autoc;
-	u32				orig_autoc2;
-	bool				orig_link_settings_stored;
-	bool				autotry_restart;
-	u8				flags;
+	s32                             mc_filter_type;
+	u32                             mcft_size;
+	u32                             vft_size;
+	u32                             num_rar_entries;
+	u32                             rar_highwater;
+	u32                             rx_pb_size;
+	u32                             max_tx_queues;
+	u32                             max_rx_queues;
+	u32                             max_msix_vectors;
+	bool                            msix_vectors_from_pcie;
+	u32                             orig_autoc;
+	u32                             orig_autoc2;
+	bool                            orig_link_settings_stored;
+	bool                            autotry_restart;
+	u8                              flags;
 };
 
 struct ixgbe_phy_info {
-	struct ixgbe_phy_operations	ops;
-	enum ixgbe_phy_type		type;
-	u32				addr;
-	u32				id;
-	enum ixgbe_sfp_type		sfp_type;
-	bool				sfp_setup_needed;
-	u32				revision;
-	enum ixgbe_media_type		media_type;
-	bool				reset_disable;
-	ixgbe_autoneg_advertised	autoneg_advertised;
-	enum ixgbe_smart_speed		smart_speed;
-	bool				smart_speed_active;
-	bool				multispeed_fiber;
-	bool				reset_if_overtemp;
+	struct ixgbe_phy_operations     ops;
+	enum ixgbe_phy_type             type;
+	u32                             addr;
+	u32                             id;
+	enum ixgbe_sfp_type             sfp_type;
+	bool                            sfp_setup_needed;
+	u32                             revision;
+	enum ixgbe_media_type           media_type;
+	bool                            reset_disable;
+	ixgbe_autoneg_advertised        autoneg_advertised;
+	enum ixgbe_smart_speed          smart_speed;
+	bool                            smart_speed_active;
+	bool                            multispeed_fiber;
+	bool                            reset_if_overtemp;
 };
 
 struct ixgbe_hw {
-	u8				*hw_addr;
-	void				*back;
-	struct ixgbe_mac_info		mac;
-	struct ixgbe_addr_filter_info	addr_ctrl;
-	struct ixgbe_fc_info		fc;
-	struct ixgbe_phy_info		phy;
-	struct ixgbe_eeprom_info	eeprom;
-	struct ixgbe_bus_info		bus;
-	u16				device_id;
-	u16				vendor_id;
-	u16				subsystem_device_id;
-	u16				subsystem_vendor_id;
-	u8				revision_id;
-	bool				adapter_stopped;
+	u8                              *hw_addr;
+	void                            *back;
+	struct ixgbe_mac_info           mac;
+	struct ixgbe_addr_filter_info   addr_ctrl;
+	struct ixgbe_fc_info            fc;
+	struct ixgbe_phy_info           phy;
+	struct ixgbe_eeprom_info        eeprom;
+	struct ixgbe_bus_info           bus;
+	u16                             device_id;
+	u16                             vendor_id;
+	u16                             subsystem_device_id;
+	u16                             subsystem_vendor_id;
+	u8                              revision_id;
+	bool                            adapter_stopped;
 };
 
-#define	ixgbe_call_func(hw, func, params, error) \
-	(func != NULL) ? func params: error
+#define ixgbe_call_func(hw, func, params, error) \
+                (func != NULL) ? func params : error
 
+
 /* Error Codes */
-#define	IXGBE_SUCCESS				0
-#define	IXGBE_ERR_EEPROM			-1
-#define	IXGBE_ERR_EEPROM_CHECKSUM		-2
-#define	IXGBE_ERR_PHY				-3
-#define	IXGBE_ERR_CONFIG			-4
-#define	IXGBE_ERR_PARAM				-5
-#define	IXGBE_ERR_MAC_TYPE			-6
-#define	IXGBE_ERR_UNKNOWN_PHY			-7
-#define	IXGBE_ERR_LINK_SETUP			-8
-#define	IXGBE_ERR_ADAPTER_STOPPED		-9
-#define	IXGBE_ERR_INVALID_MAC_ADDR		-10
-#define	IXGBE_ERR_DEVICE_NOT_SUPPORTED		-11
-#define	IXGBE_ERR_MASTER_REQUESTS_PENDING	-12
-#define	IXGBE_ERR_INVALID_LINK_SETTINGS		-13
-#define	IXGBE_ERR_AUTONEG_NOT_COMPLETE		-14
-#define	IXGBE_ERR_RESET_FAILED			-15
-#define	IXGBE_ERR_SWFW_SYNC			-16
-#define	IXGBE_ERR_PHY_ADDR_INVALID		-17
-#define	IXGBE_ERR_I2C				-18
-#define	IXGBE_ERR_SFP_NOT_SUPPORTED		-19
-#define	IXGBE_ERR_SFP_NOT_PRESENT		-20
-#define	IXGBE_ERR_SFP_NO_INIT_SEQ_PRESENT	-21
-#define	IXGBE_ERR_NO_SAN_ADDR_PTR		-22
-#define	IXGBE_ERR_FDIR_REINIT_FAILED		-23
-#define	IXGBE_ERR_EEPROM_VERSION		-24
-#define	IXGBE_ERR_NO_SPACE			-25
-#define	IXGBE_ERR_OVERTEMP			-26
-#define	IXGBE_ERR_FC_NOT_NEGOTIATED		-27
-#define	IXGBE_ERR_FC_NOT_SUPPORTED		-28
-#define	IXGBE_ERR_FLOW_CONTROL			-29
-#define	IXGBE_NOT_IMPLEMENTED			0x7FFFFFFF
+#define IXGBE_SUCCESS                           0
+#define IXGBE_ERR_EEPROM                        -1
+#define IXGBE_ERR_EEPROM_CHECKSUM               -2
+#define IXGBE_ERR_PHY                           -3
+#define IXGBE_ERR_CONFIG                        -4
+#define IXGBE_ERR_PARAM                         -5
+#define IXGBE_ERR_MAC_TYPE                      -6
+#define IXGBE_ERR_UNKNOWN_PHY                   -7
+#define IXGBE_ERR_LINK_SETUP                    -8
+#define IXGBE_ERR_ADAPTER_STOPPED               -9
+#define IXGBE_ERR_INVALID_MAC_ADDR              -10
+#define IXGBE_ERR_DEVICE_NOT_SUPPORTED          -11
+#define IXGBE_ERR_MASTER_REQUESTS_PENDING       -12
+#define IXGBE_ERR_INVALID_LINK_SETTINGS         -13
+#define IXGBE_ERR_AUTONEG_NOT_COMPLETE          -14
+#define IXGBE_ERR_RESET_FAILED                  -15
+#define IXGBE_ERR_SWFW_SYNC                     -16
+#define IXGBE_ERR_PHY_ADDR_INVALID              -17
+#define IXGBE_ERR_I2C                           -18
+#define IXGBE_ERR_SFP_NOT_SUPPORTED             -19
+#define IXGBE_ERR_SFP_NOT_PRESENT               -20
+#define IXGBE_ERR_SFP_NO_INIT_SEQ_PRESENT       -21
+#define IXGBE_ERR_NO_SAN_ADDR_PTR               -22
+#define IXGBE_ERR_FDIR_REINIT_FAILED            -23
+#define IXGBE_ERR_EEPROM_VERSION                -24
+#define IXGBE_ERR_NO_SPACE                      -25
+#define IXGBE_ERR_OVERTEMP                      -26
+#define IXGBE_ERR_FC_NOT_NEGOTIATED             -27
+#define IXGBE_ERR_FC_NOT_SUPPORTED              -28
+#define IXGBE_ERR_FLOW_CONTROL                  -29
+#define IXGBE_ERR_SFP_SETUP_NOT_COMPLETE        -30
+#define IXGBE_ERR_PBA_SECTION                   -31
+#define IXGBE_ERR_INVALID_ARGUMENT              -32
+#define IXGBE_NOT_IMPLEMENTED                   0x7FFFFFFF
 
-#ifndef UNREFERENCED_PARAMETER
-#define	UNREFERENCED_PARAMETER(_p)		(_p);
-#define	UNREFERENCED_2PARAMETER(_p, _q) 	(_p); (_q);
-#define	UNREFERENCED_3PARAMETER(_p, _q, _r)	(_p); (_q); (_r);
-#define	UNREFERENCED_4PARAMETER(_p, _q, _r, _s)	(_p); (_q); (_r); (_s);
-#endif
 
-#endif /* _IXGBE_TYPE_H */
+#endif /* _IXGBE_TYPE_H_ */
